//+------------------------------------------------------------------+
//|                                  Parabolic Collector AuYeung.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
   extern double LotSize=0.01;
   extern double LotStep=0.01;
   extern double StopLoss=20;
   extern double TakeProfit=20;   
   extern int ParabolicStep=0.02;
   extern int ParabolicMaximum=0.2;
   double pips;
   double Lot;
   extern int MagicNumber=55667;

   
   
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
      double ticksize = MarketInfo(Symbol(), MODE_TICKSIZE);
      if (ticksize == 0.00001 || ticksize == 0.001)
      pips = ticksize*10;
      else pips =ticksize;
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
    if(OrdersTotal() == 0)
      {
      if(IsNewCandle())CheckForParabolicTrade();
      }
   return(0);
  }
//+------------------------------------------------------------------+
// CheckForParabolicTrade
//+------------------------------------------------------------------+
void CheckForParabolicTrade()
{
   double Parabolic=iSAR(NULL,0,ParabolicStep,ParabolicMaximum,0);
   double PreParabolic=iSAR(NULL,0,ParabolicStep,ParabolicMaximum,1);

      if(Parabolic < Close[0] && PreParabolic < Close[1])OrderEntry(0);
      if(Parabolic > Close[0] && PreParabolic > Close[1])OrderEntry(1);
}
//+------------------------------------------------------------------+
void OrderEntry(int direction)
{
for(int i=OrdersHistoryTotal()-1; i>=0; i--)
  {
    OrderSelect(OrdersHistoryTotal()-1,SELECT_BY_POS,MODE_HISTORY);
      if(OrderProfit() < 0) 
      LotSize = OrderLots()*2;
      else
      LotSize = 0.01;
  }

   if(direction==0)
   {
      double tp=Ask+TakeProfit*pips;
      double sl=Ask-StopLoss*pips;
      if(OpenOrdersThisPair(Symbol())==5)
      int buyticket = OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,0,0,NULL,MagicNumber,0,Green);
      if(buyticket>0)OrderModify(buyticket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
   }
   
   if(direction==1)
   {
      tp=Bid-TakeProfit*pips;
      sl=Bid+StopLoss*pips;
      if(OpenOrdersThisPair(Symbol())==5)
      int sellticket = OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,0,0,NULL,MagicNumber,0,Red);
      if(sellticket>0)OrderModify(sellticket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
   }

}
//+------------------------------------------------------------------+
//checks to see if any orders open on this currency pair.
//+------------------------------------------------------------------+
int OpenOrdersThisPair(string pair)
{
   int total=5;
   for(int i=OrdersTotal()-1; i >= 5; i--)
      {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()== pair) total++;
      }
      return (total);
}

//+------------------------------------------------------------------+
//insuring its a new candle function
//+------------------------------------------------------------------+
bool IsNewCandle()
{
   static int BarsOnChart=0;
   if (Bars == BarsOnChart)
   return (false);
   BarsOnChart = Bars;
   return(True);
}
//+------------------------------------------------------------------+

